#!/usr/bin/wish

#Para q funcione con enlaces, consigue en program_dir el directorio desde el q se ejecuta

if {[catch {file readlink [info script]} res]!=0} {
  set program_dir [file dirname [info script]]
} else {
   set resdir [file dirname $res]
   while {[catch {file readlink $res} res2]==0} {
     set res $res2
     if { [string range $res2 0 0]=="/" } {
       set resdir [file dirname $res2]
     } else {
       set resdir [file join $resdir [file dirname $res2]]
     }
   }
   set program_dir $resdir
}

source [file join $program_dir dkffont.tcl]	;# Widget de seleccion de Fuentes
source [file join $program_dir funciones.tcl]	;# Funciones varias
source [file join $program_dir colores2.tcl]	;# Para los colores
source [file join $program_dir servidores.tcl]	;# Contiene los datos de los servidores

set ver "04.00"
set servidor "plugged"
set mensaje "$servidor"
set numero ""
set count 0
set fuente {Courier 14}
set fondo black
set frente green

set lista_servidores { plugged everyday vodafone amena navegalia gomobile samsung universia}

set plugged(espacio) "+"
set plugged(maxcar) 110
set plugged(reg) 1

set everyday(espacio) "+"
set everyday(maxcar) 126
set everyday(reg) 1

set vodafone(espacio) "+"
set vodafone(maxcar) 160
set vodafone(reg) 0

set amena(espacio) "+"
set amena(maxcar) 500
set amena(reg) 1

set navegalia(espacio) "+"
set navegalia(maxcar) 120
set navegalia(reg) 1

set gomobile(espacio) "+"
set gomobile(maxcar) 141
set gomobile(reg) 1

set samsung(espacio) "+"
set samsung(maxcar) 160
set samsung(reg) 0

set universia(espacio) "+"
set universia(maxcar) 133
set universia(reg) 1

proc cambia_servidor { server } {

global servidor count
.uno.fagenda.lbarra configure -text $server
set servidor $server
upvar #0 $servidor serv
set cont [ expr $serv(maxcar) - ([string length [.uno.ftexto.tentrada get 0.0 end]]-1)]
	if { $cont <= 0 } {
		set msg [.uno.ftexto.tentrada get 0.0 end]
		set long [string length $msg ]
		.uno.ftexto.tentrada delete 0.0 end
		.uno.ftexto.tentrada insert 0.0 [string range $msg 0 [expr $serv(maxcar) -1]]
		set count [ expr $serv(maxcar) - ([string length [.uno.ftexto.tentrada get 0.0 end]]-1)]
	}
#si no es de registro ocultamos los login y passwd
if {$serv(reg)} {

.uno.datos.llogin configure -state active
.uno.datos.elogin configure -state normal
.uno.datos.bdesplega configure -state active
.uno.datos.lpasswd configure -state active
.uno.datos.epasswd configure -state normal

} else {

.uno.datos.llogin configure -state disabled
.uno.datos.elogin configure -state disabled
.uno.datos.bdesplega configure -state disabled
.uno.datos.lpasswd configure -state disabled
.uno.datos.epasswd configure -state disabled

 }
}

proc barra_progreso { porcentaje } {
set alto [ winfo height .uno.fprogbar ]
set altura [ expr $alto*$porcentaje/100 ]
.uno.fprogbar.fbarra config -height $altura
update idletasks
}

proc debug {texto} {
.dos.debug insert end "\n$texto"
.dos.debug see end
}

proc cancelar {conexion} {
.uno.fenvia.bcancelar configure -command "close $conexion;\
			.uno.fenvia.bcancelar configure -state disabled;\
			.uno.fenvia.benviar configure -state normal;\
			.uno.fenvia.bcontar configure -state normal;\
			debug \"Envio Cancelado\n\n\";"
}

proc barra_estado { estado } {
.uno.fstatbar.lbarra config -text $estado
update idletasks
}

proc boton_enviar { estado } {
.uno.fenvia.benviar config -state $estado
update idletasks
}

proc boton_cancelar { estado } {
.uno.fenvia.bcancelar config -state $estado
update idletasks
}

proc boton_contar { estado } {
.uno.fenvia.bcontar config -state $estado
update idletask
}




#########################################
# Ventana de Configuracion              #
#########################################

proc guardar_conf {} {
global servidor fuente
global pos_x pos_y pos_x_cuen pos_y_cuen
set fichero [open "~/.linsms/setup" w]
puts $fichero $servidor
puts $fichero $fuente
puts $fichero [.uno.ftexto.tentrada cget -fg] ;#El color de las letras
puts $fichero [.uno.ftexto.tentrada cget -bg] ;#El color del fondo
puts $fichero $pos_x;#Posicion X de la ventana
puts $fichero $pos_y;#Posicion Y de la ventana
puts $fichero $pos_x_cuen;#Posicion X de la ventana de cuentas
puts $fichero $pos_y_cuen;#Posicion Y de la ventana de cuentas
close $fichero
tk_messageBox -type ok -message "Configuracion salvada:\nServidor:$servidor\nFuente:$fuente\nColor Letra:[.uno.ftexto.tentrada cget -fg]\nColor Fondo:[.uno.ftexto.tentrada cget -bg]"
set mensaje $servidor
}

proc seleccionar { ventana } {
set indice [$ventana curselection]
set seleccion [$ventana get $indice]
return $seleccion
}

proc configuracion { w } {
global remitente servidor lista_servidores
if {![winfo exists $w]} {

toplevel $w -height 110

frame $w.fremitente -relief flat
label $w.fremitente.lremitente -text "Remitente: "
entry $w.fremitente.eremitente -textvar remitente

frame $w.fs_smtp -relief flat
label $w.fs_smtp.lservidor -text "Servidor SMTP: "
entry $w.fs_smtp.eservidor -textvar servidor_smtp

frame $w.fservidor -relief flat
label $w.fservidor.lservidor -text "Servidor: "
entry $w.fservidor.eservidor -textvar servidor -state disabled

frame $w.flist -relief flat
listbox $w.flist.llist -height 3 -selectmode single -yscrollcommand "${w}.flist.slist set"
scrollbar $w.flist.slist -command "${w}.flist.llist yview"
button $w.flist.blist -text "Cerrar" -command "destroy $w" -padx 15 -relief ridge

bind $w.flist.llist <ButtonRelease-1> {+set servidor [seleccionar %W]}
bind $w <Destroy> {+ guardar_conf}

foreach server $lista_servidores {
$w.flist.llist insert end $server
}

pack $w.fremitente -side top -fill x
pack $w.fremitente.lremitente -side left
pack $w.fremitente.eremitente -side right
pack $w.fs_smtp -side top -fill x
pack $w.fs_smtp.lservidor -side left
pack $w.fs_smtp.eservidor -side right
pack $w.fservidor -side top -fill x
pack $w.fservidor.lservidor -side left
pack $w.fservidor.eservidor -side right
pack $w.flist -side bottom -fill x
pack $w.flist.llist -side left
pack $w.flist.slist -side left -fill y
pack $w.flist.blist -side right -padx 5
wm resizable $w 0 0
wm title $w "LinSMS (configuracion)"
} else {
        focus -force $w
       }
}

#########################################
# Ventana de Agenda                     #
#########################################

proc seleccion_agenda { w lista } {
upvar #0 $lista listado
set nombre [$w get [$w curselection]]
set ventana [winfo parent [winfo parent $w]]
$ventana.datos.enombre delete 0 end
$ventana.datos.enombre insert 0 $nombre
update idletasks
regsub -all " " $nombre "" nombre
return $listado($nombre)
}

proc modo_operacion { modo w lista } {
$w.datos.cerrar config -state disabled
$w.datos.botonera.boton1 config -text "S" -command "$modo $w $lista"
$w.datos.botonera.boton2 config -text "No" -command "cancelar_modo $w"
}

proc borrar { w lista } {
upvar #0 $lista listado
set nombre [$w.datos.enombre get]
set posicion [lsearch $listado(lista) $nombre]
set listado(lista) [lreplace $listado(lista) $posicion $posicion]
set listado(lista) [lsort -dictionary $listado(lista)]
$w.flist.llist delete 0 end
foreach i $listado(lista) {
       $w.flist.llist insert end $i
      }
if [catch { set fichero [open "~/.linsms/agenda" w ]
            foreach i $listado(lista) {
                   regsub -all " " $i "" indice
                   puts $fichero "${i}:$listado($indice)"
                   }
            close $fichero
            regsub -all " " $nombre "" indice
            unset listado($indice)
}] {
    tk_messageBox -type ok -message "Error borrando entrada de la agenda."
   }
$w.datos.botonera.boton1 config -text "Aadir" -command "modo_operacion aadir $w $lista"
$w.datos.botonera.boton2 config -text "Borrar" -command "modo_operacion borrar $w $lista"
$w.datos.cerrar config -state normal
}

proc aadir { w lista } {
upvar #0 $lista listado
set nombre [$w.datos.enombre get]
set telefono [$w.datos.enumero get]
regsub -all " " $nombre "" indice

if [info exists listado($indice)] {
   tk_messageBox -type ok -message "El nombre ya existe."
  } else {
         if [catch {
            set fichero [open "~/.linsms/agenda" a+]
            puts $fichero "$nombre:$telefono"
            close $fichero
          }] {
              tk_messageBox -type ok -message "Error aadiendo a la agenda."
             } else {
                     set listado($indice) $telefono
                     lappend listado(lista) $nombre
                     set listado(lista) [lsort -dictionary $listado(lista)]
                     $w.flist.llist delete 0 end
                     foreach i $listado(lista) {
                     $w.flist.llist insert end $i
                            }
                    }
         $w.datos.botonera.boton1 config -text "Aadir" -command "modo_operacion aadir $w $lista"
         $w.datos.botonera.boton2 config -text "Borrar" -command "modo_operacion borrar $w $lista"
         $w.datos.cerrar config -state normal
        }
}

proc agenda { w lista } {
global numero
upvar #0 $lista listado
if {![winfo exists $w]} {
  toplevel $w
  frame $w.flist -relief flat
  listbox $w.flist.llist -height 9 -selectmode single -yscrollcommand "${w}.flist.slist set"
  scrollbar $w.flist.slist -command "${w}.flist.llist yview"
  frame $w.datos -relief flat
  label $w.datos.lnombre -text "Nombre:" -relief flat -anchor w
  entry $w.datos.enombre -text ""
  label $w.datos.lnumero -text "Nmero:" -relief flat -anchor w
  entry $w.datos.enumero -textvar numero
  frame $w.datos.botonera -relief flat
  button $w.datos.botonera.boton1 -text "Aadir" -relief ridge -command "modo_operacion aadir $w $lista"
  button $w.datos.botonera.boton2 -text "Borrar" -relief ridge -command "modo_operacion borrar $w $lista"
  button $w.datos.cerrar -text "Cerrar" -relief ridge -command "destroy $w"
bind $w.flist.llist <ButtonRelease-1> {+set numero [seleccion_agenda %W listado]}
bind $w.flist.llist <Double-Button-1> {destroy .uno.agenda}

if { ![info exists listado(lista)] } {
if [catch {
           set fichero [open "~/.linsms/agenda"]
           while {![eof $fichero]} {
                set linea [split [gets $fichero] : ]
                if {[llength $linea]>1} {
                   regsub -all " " [lindex $linea 0] "" nombre
                   set listado($nombre) [lindex $linea 1]
                   lappend listado(lista) [lindex $linea 0]
                  }
                }
           set listado(lista) [lsort -dictionary $listado(lista)]
           foreach i $listado(lista) {
                  $w.flist.llist insert end $i
                 }
           close $fichero
          }] { .dos.debug insert end "\n\nError accediendo a la agenda.\n" }
} else {
        set listado(lista) [lsort -dictionary $listado(lista)]
        foreach i $listado(lista) {
        $w.flist.llist insert end $i
               }
       }
pack $w.flist -side left
pack $w.flist.llist -side left
pack $w.flist.slist -side left -fill y
pack $w.datos -side top
pack $w.datos.lnombre -side top -fill x
pack $w.datos.enombre -side top -fill x
pack $w.datos.lnumero -side top -fill x
pack $w.datos.enumero -side top -fill x
pack $w.datos.botonera -side top -fill x
pack $w.datos.botonera.boton1 -side left -padx 5 -pady 5
pack $w.datos.botonera.boton2 -side right -padx 5 -pady 5
pack $w.datos.cerrar -side top -pady 5
wm resizable $w 0 0


 } else {
         focus -force $w
        }
}

#########################################
# Ventana de Cuentas                    #
#########################################


proc seleccion_cuentas { w lista } {
global servidor
upvar #0 $lista lcuentas
set nombre [$w get [$w curselection]]
set ventana [winfo parent [winfo parent $w]]
$ventana.datos.elogin delete 0 end
$ventana.datos.elogin insert 0 $nombre
update idletasks
set ind "$servidor:$nombre"
return [lindex [split $lcuentas($ind) :] 1]
}

proc modo_operacion_cuentas { modo w lista } {
$w.datos.cerrar config -state disabled
$w.datos.botonera.boton1 config -text "S" -command "$modo $w $lista"
$w.datos.botonera.boton2 config -text "No" -command "cancelar_modo $w $lista"
}


proc cancelar_modo { w lista} {
$w.datos.botonera.boton1 config -text "Aadir" -command "modo_operacion aadir $w $lista"
$w.datos.botonera.boton2 config -text "Borrar" -command "modo_operacion borrar $w $lista"
$w.datos.cerrar config -state normal
}

proc borrar_cuentas { w lista } {
global servidor
upvar #0 $lista lcuentas

set nombre [$w.datos.elogin get]
set indice "$servidor:$nombre"
set posicion [lsearch $lcuentas(lista) $indice]

   #borro la posicion indice del array
   unset lcuentas($indice)
   #esta linea elimina de la lista de indices la entrada buscada
   set lcuentas(lista) [lreplace $lcuentas(lista) $posicion $posicion]

$w.flist.llist delete 0 end
foreach i $lcuentas(lista) {
   if {[string compare $servidor [lindex [split $i :] 0]]==0} {
      $w.flist.llist insert end [lindex [split $i :] 1]
      }
   }
if [catch { set fichero [open "~/.linsms/cuentas" w ]
            foreach i $lcuentas(lista) {
		   puts $fichero "[lindex [split $i :] 0]:[lindex [split $i :] 1]:[lindex [split $lcuentas($i) :] 1]"
	            }
            close $fichero
}] {
    tk_messageBox -type ok -message "Error borrando entrada de cuentas."
   }

$w.datos.botonera.boton1 config -text "Aadir" -command "modo_operacion aadir $w $lista"
$w.datos.botonera.boton2 config -text "Borrar" -command "modo_operacion borrar $w $lista"
$w.datos.cerrar config -state normal
}


proc aadir_cuentas { w lista } {
global servidor
upvar #0 $lista lcuentas
set login [$w.datos.elogin get]
set password [$w.datos.epasswd get]

set ind "$servidor:$login"
puts "ind:$ind"
puts "pas:$password"
#puts "cuen:$lcuentas($ind)"
#no puedo preguntar por $lcuenta($ind) pq no existe ese indice!
if {[info exists lcuentas($ind)]} {
   tk_messageBox -type ok -message "La cuenta ya existe."
  } else {
         if [catch {
            set fichero [open "~/.linsms/cuentas" a+]
            puts $fichero "$servidor:$login:$password"
            close $fichero

          }] {
              tk_messageBox -type ok -message "Error aadiendo a la agenda."
             } else {
		     set dat "$servidor:$password"
		     lappend lcuentas($ind) $dat
                     lappend lcuentas(lista) $ind

                     set lcuentas(lista) [lsort -dictionary $lcuentas(lista)]
                     $w.flist.llist delete 0 end
                     foreach i $lcuentas(lista) {
		        #si el servidor es $servidor
	        	if {[string compare $servidor [lindex [split $i :] 0]]==0} {
			   $w.flist.llist insert end [lindex [split [lindex $i 0] :] 1]
		   	   }
         		}
                    }

	$w.datos.botonera.boton1 config -text "Aadir" -command "modo_operacion_cuentas aadir_cuentas $w $lista"
	$w.datos.botonera.boton2 config -text "Borrar" -command "modo_operacion_cuentas borrar_cuentas $w $lista"
	$w.datos.cerrar config -state normal
	}
}

proc cuentas { w lista } {
global numero
global servidor
global pos_x_cuen
global pos_y_cuen
upvar #0 $lista lcuentas
if {![winfo exists $w]} {
  toplevel $w
  wm geometry $w +$pos_x_cuen+$pos_y_cuen
  bind $w <Configure> {global pos_x_cuen pos_y_cuen;set pos_x_cuen %x;set pos_y_cuen %y}
  frame $w.flist -relief flat
  listbox $w.flist.llist -height 9 -selectmode single -yscrollcommand "${w}.flist.slist set"
  scrollbar $w.flist.slist -command "${w}.flist.llist yview"
  frame $w.datos -relief flat
  label $w.datos.llogin -text "Login:" -relief flat -anchor w
  entry $w.datos.elogin -textvar login
  label $w.datos.lpasswd -text "Password:" -relief flat -anchor w
  entry $w.datos.epasswd -textvar passwd -show *
  frame $w.datos.botonera -relief flat
  button $w.datos.botonera.boton1 -text "Aadir" -relief ridge -command "modo_operacion_cuentas aadir_cuentas $w $lista"
  button $w.datos.botonera.boton2 -text "Borrar" -relief ridge -command "modo_operacion_cuentas borrar_cuentas $w $lista"
  button $w.datos.cerrar -text "Cerrar" -relief ridge -command "destroy $w"
bind $w.flist.llist <ButtonRelease-1> {+set passwd [seleccion_cuentas %W lcuentas]}
bind $w.flist.llist <Double-Button-1> {destroy .uno.cuentas}

if { ![info exists lcuentas(lista)] } {
if [catch {
	   set fichero [open "~/.linsms/cuentas"]
    	   set linea ""

           while {![eof $fichero]} {
                set linea [split [gets $fichero] : ]
		set elementos [llength $linea]
		set serv [lindex $linea 0]
		set log [lindex $linea 1]
		set pas [lindex $linea 2]
                if {$elementos>2} {
		      set dat "$serv:$pas"
		      set ind "$serv:$log"
		      lappend lcuentas($ind) $dat
                      lappend lcuentas(lista) $ind
		   }
                }
	   #Si hemos leido algo:
	   if {[info exists lcuentas(lista)]} {
	      set lcuentas(lista) [lsort -dictionary $lcuentas(lista)]
       	      $w.flist.llist delete 0 end
              foreach i $lcuentas(lista) {
	      #si el servidor es $servidor
	        if {[string compare $servidor [lindex [split $i :] 0]]==0} {
			$w.flist.llist insert end [lindex [split [lindex $i 0] :] 1]
		   }
	         }
		}
           close $fichero
          }] { .dos.debug insert end "\n\nError accediendo a la agenda de cuentas.\n\n\n" }
} else {
        set lcuentas(lista) [lsort -dictionary $lcuentas(lista)]
        foreach i $lcuentas(lista) {
		#si el servidor es $servidor
	        if {[string compare $servidor [lindex [split $i :] 0]]==0} {
			$w.flist.llist insert end [lindex [split [lindex $i 0] :] 1]
		   }
	   }
       }
pack $w.flist -side left
pack $w.flist.llist -side left
pack $w.flist.slist -side left -fill y
pack $w.datos -side top
pack $w.datos.llogin -side top -fill x
pack $w.datos.elogin -side top -fill x
pack $w.datos.lpasswd -side top -fill x
pack $w.datos.epasswd -side top -fill x
pack $w.datos.botonera -side top -fill x
pack $w.datos.botonera.boton1 -side left -padx 5 -pady 5
pack $w.datos.botonera.boton2 -side right -padx 5 -pady 5
pack $w.datos.cerrar -side top -pady 5
wm resizable $w 0 0


 } else {
         focus -force $w
        }
}


#########################################
# Ventana Principal                     #
#########################################

menu .menu -tearoff 0 -type menubar -borderwidth 1
  .menu add cascade -label "Archivo" -menu .menu.archivo -underline 0
menu .menu.archivo -tearoff 0 -type normal -borderwidth 1
  .menu.archivo add cascade -label "Configuracin" -underline 0 -menu .menu.archivo.configuracion
menu .menu.archivo.configuracion -tearoff 0 -type normal -borderwidth 1
  .menu.archivo.configuracion add command -label "Guardar Configuracion" -underline 0 -command { guardar_conf;#configuracion .uno.conf }
  .menu.archivo.configuracion add command -label "Fuentes" -underline 0 -command {cambia_fuente}
  .menu.archivo.configuracion add command -label "Colores" -underline 0 -command {elige_colores}

  .menu.archivo add command -label "Agenda" -underline 0 -command {agenda .uno.agenda listado}
  .menu.archivo add command -label "Cuentas" -underline 1 -command {cuentas .uno.cuentas lcuentas}

  .menu add cascade -label "Servidor" -menu .menu.servidores -underline 0
menu .menu.servidores -tearoff 0 -type normal -borderwidth 1
  .menu.servidores add command -command {cambia_servidor plugged} -label "Plugged (R)(NV) 110" -underline 0
  .menu.servidores add command -command {cambia_servidor everyday} -label "EveryDay (R) 126" -underline 0
  .menu.servidores add command -command {cambia_servidor amena} -label "Amena (R) 500" -underline 0
  .menu.servidores add command -command {cambia_servidor navegalia} -label "Navegalia (R) 135" -underline 0
  .menu.servidores add command -command {cambia_servidor gomobile} -label "Gomobile (R)(NAm) 141" -underline 0
  .menu.servidores add command -command {cambia_servidor universia} -label "Universia (R) 133" -underline 0
  .menu.servidores add separator
  .menu.servidores add command -command {cambia_servidor samsung} -label "Samsung 160" -underline 0 -underline 0
  .menu.servidores add command -command {cambia_servidor vodafone} -label "Vodafone 136" -underline 0 -underline 0
  .menu.servidores add separator
  .menu.servidores add cascade -label "Siglas ->" -menu .menu.servidores.siglas -underline 0
menu .menu.servidores.siglas -tearoff 0 -type normal -borderwidth 1
       .menu.servidores.siglas add command -label "(R) -> Registro"
       .menu.servidores.siglas add command -label "(NV) -> No envia a Vodafone"
       .menu.servidores.siglas add command -label "(NAm) -> No envia a Amena"
menu .menu.ayuda -tearoff 0 -type normal -borderwidth 1
  .menu add cascade -label "Ayuda" -menu .menu.ayuda -underline 1
  .menu.ayuda add command -label "Acerca de..." -command {tk_messageBox -type ok -icon info -message "Creado por KNO en TCL/TK\nlinsms@guay.com\nhttp://linsms.guay.com"}
  .menu.ayuda add command -label "Actualizar" -command {actualizar}

pack .menu -side top -fill x



frame .uno

frame .uno.fprogbar -bd 2 -width 15 -relief sunken
frame .uno.fprogbar.fbarra -relief flat -bg blue -width 10 -height 0
pack .uno.fprogbar -side left -fill y
pack .uno.fprogbar.fbarra -side bottom -fill y -fill x

frame .uno.fagenda
button .uno.fagenda.bagenda -text "Agenda" -height 1 -relief ridge -command { agenda .uno.agenda listado }
label .uno.fagenda.lbarra -text $servidor -width 15 -relief sunken
pack .uno.fagenda -side top -fill x
pack .uno.fagenda.bagenda -side left
pack .uno.fagenda.lbarra -side right


frame .uno.fnum -bd 3
label .uno.fnum.lnum -text "Nm Movil" -padx 20
entry .uno.fnum.enumero -textvar numero  -width 14 -font $fuente -bg $fondo -fg $frente
menubutton .uno.fnum.bdesplega  -menu .uno.fnum.bdesplega.mdesplega -borderwidth 1  -text "V" -relief raised
#creamos una entrada por cada nombre de la agenda:
menu .uno.fnum.bdesplega.mdesplega -tearoff 0
#miramos si existe el fichero ~/.linsms/agenda y si es asi lo abrimos.
#en otro caso damos error
if {[file exists "~/.linsms/agenda"]} {

   set fichero [open "~/.linsms/agenda"]
   while {![eof $fichero]} {
      set linea [split [gets $fichero] : ]
      if {[llength $linea]>1} {
         set nombre "[lindex $linea 0]:[lindex $linea 1]"
	 set n [lindex $linea 1]
         lappend lnom "$nombre"
	 set lnumeros($nombre) $n
      };#end if
      };#end while
   foreach i $lnom {
         .uno.fnum.bdesplega.mdesplega add command -label "$i" -command {set numero [lindex [split [.uno.fnum.bdesplega.mdesplega entrycget active -label] : ] 1]}
      };#end foreach
} else {
#no existe-> mensaje de error
   tk_messageBox -type ok -message "No se ha encontrado el fichero de agenda."
}

pack .uno.fnum.bdesplega -side right
pack .uno.fnum.enumero -side right -fill x
pack .uno.fnum.lnum -side right -fill x
pack .uno.fnum -side top -fill x


frame .uno.datos -bd 2
label .uno.datos.llogin -text "Login: "
entry .uno.datos.elogin -textvar login -width 5 -font $fuente -bg $fondo -fg $frente
menubutton .uno.datos.bdesplega -menu .uno.datos.bdesplega.mdesplega -borderwidth 1 -text "V" -relief raised
#creamos una entrada por cada password en cuentas
menu .uno.datos.bdesplega.mdesplega -tearoff 0
.uno.datos.bdesplega.mdesplega add command -command {cuentas .uno.cuentas lcuentas} -label "Cuentas"

label .uno.datos.lpasswd -text "Password: "
entry .uno.datos.epasswd -textvar passwd -width 9 -show * -font $fuente -bg $fondo -fg $frente
pack .uno.datos.llogin -side left
pack .uno.datos.elogin -side left
pack .uno.datos.bdesplega -side left
pack .uno.datos.lpasswd -side left
pack .uno.datos.epasswd -side left
pack .uno.datos -side top -fill x

frame .uno.ftexto -bd 2
text .uno.ftexto.tentrada -height 4 -width 5 -yscrollcommand { .uno.ftexto.sy set } -bg $fondo -fg $frente -font $fuente -wrap word
scrollbar .uno.ftexto.sy -command { .uno.ftexto.tentrada yview }
pack .uno.ftexto.tentrada -side left -fill both -expand true
pack .uno.ftexto.sy -side right -fill y
pack .uno.ftexto -side top -fill x

frame .uno.fenvia -bd 2
button .uno.fenvia.bcontar -text "Quedan\n?\nSMS" -command { cuantos_quedan_$servidor [.uno.datos.elogin get] [.uno.datos.epasswd get]}
button .uno.fenvia.benviar -text "Enviar Mensaje" -command { comprueba }
button .uno.fenvia.bcancelar -text "Cancelar" -command {cancela_conexion} -state disabled -width 5

pack .uno.fenvia.bcontar -side left
pack .uno.fenvia.bcancelar -side right
pack .uno.fenvia.benviar  -side left


pack .uno.fenvia -side top -fill x

frame .uno.fstatbar
label .uno.fstatbar.lbarra -text "LinSMS Version $ver" -relief sunken
label .uno.fstatbar.lcount -textvar count -width 5 -relief sunken
pack .uno.fstatbar.lcount -side right
pack .uno.fstatbar.lbarra -fill x
pack .uno.fstatbar -side bottom -fill x

frame .dos -width 100 -bg gray70
label .dos.ldebug -text "Ventana de Debug" -width 30
text .dos.debug -yscrollcommand { .dos.debug.sy set } -xscrollcommand { .dos.debug.sx set } -font $fuente -wrap none -bg $fondo -fg $frente
scrollbar .dos.debug.sy -command {.dos.debug yview }
scrollbar .dos.debug.sx -command {.dos.debug xview } -orient h

pack .dos.ldebug -side top
pack .dos.debug.sy -side right -fill y
pack .dos.debug.sx -side bottom -fill x
pack .dos.debug -side right -fill both -expand yes


pack .dos -side right -fill both -expand true
pack .uno -side left -fill both

wm resizable . 1 1
wm geometry . 475x285
wm title . "LinSMS by KNO"
focus -force .
focus -force .uno.fnum.enumero

bind msg <KeyPress-Return> {focus -force .uno.fenvia.benviar}
bind msg <KeyPress> {
	upvar #0 $servidor serv
	set count [ expr $serv(maxcar) - ([string length [.uno.ftexto.tentrada get 0.0 end]]-1)]
	if { $count <= 0 } {
		set msg [.uno.ftexto.tentrada get 0.0 end]
		set long [string length $msg ]
		.uno.ftexto.tentrada delete 0.0 end
		.uno.ftexto.tentrada insert 0.0 [string range $msg 0 [expr $serv(maxcar) -1]]}

	}
bind msg <Escape> {destroy .}
bind . <Escape> {destroy .}
bind .uno.fenvia.benviar <Key-Return> { manda }
bind .uno.fenvia.benviar <Escape> {destroy .}
bindtags .dos.debug {.dos.debug Text .dos. all debug }
bindtags .uno.ftexto.tentrada {.uno.ftexto.tentrada Text .uno. all msg }
bind . <Configure> {global pos_x pos_y;set pos_x %x; set pos_y %y;puts stdout "x:$pos_x y:$pos_y"}


#########################################
# Cargando configuracion                #
#########################################

if {![file exists "~/.linsms"]} {
     #crear directorios
     if {![file isdirectory "~/.linsms"]} { file mkdir "~/.linsms"}
     #crear directorios
} else {
     #leer datos
       if [catch {
         set fichero [open "~/.linsms/setup"]
         set servidor [gets $fichero]
	 cambia_servidor $servidor
	 set fuente [gets $fichero]
	 pon_fuente $fuente
	 set letras [gets $fichero]
	 set fondo [gets $fichero]
	 cambia_colores  $letras $fondo
	 set pos_x [gets $fichero]
	 set pos_y [gets $fichero]
	 wm geometry . +$pos_x+$pos_y
	 set pos_x_cuen [gets $fichero]
	 set pos_y_cuen [gets $fichero]
	 close $fichero
       }] {
           tk_messageBox -type ok -message "Error leyendo fichero de configuracin"
          }
     #leer datos
       }


#funcion intermedia para ver si podemos hacer un cancel y q se refresque la ventana
proc manda {} {
   comprueba
}


proc comprueba {} {
  global numero remitente servidor count ver estado

  set error [catch {expr $numero + 1}]
  set error [expr $error || [expr [string length $numero]!= 9]]
  if {$error} {
    tk_messageBox -type ok -message "El telefono no es correcto"
  } else {
    if { (([string compare $servidor "samsung"]!=0)&&([string compare $servidor "vodafone"]!=0))&&(([string compare [.uno.datos.elogin get] ""]==0)||([string compare [.uno.datos.epasswd get] ""]==0)) } {
	tk_messageBox -type ok -message "Ni el login ni el password pueden ser vacios."
    } else {
    set mensaje [.uno.ftexto.tentrada get 1.0 end]
    set estado 0
    envia_sms_$servidor [.uno.datos.elogin get] [.uno.datos.epasswd get] $numero $mensaje $count 0 0

    }
  }
}

proc traduce { txt serv_ext} {
 global count
 upvar #0 $serv_ext servidor
 set espacio $servidor(espacio)
 set texto ""
 for {set i 0} {$i < [string length $txt]} {incr i} {
     set letra [string index $txt $i]
     if {([string compare $letra " "]==0)||([string compare $letra "\n"]==0)} {
        set letra $espacio
       }
     set texto $texto$letra
    }
 set long [expr ([string length $texto] - 1)]
 return [string range $texto 0 $long]
}
